CodeForces 653 A. Bear and Three Balls——(IndiaHacks 2016 - Online Edition (Div. 1 + Div. 2))

传送门

A. Bear and Three Balls

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

Limak is a little polar bear. He has n balls, the i-th
ball has size ti.

Limak wants to give one ball to each of his three friends. Giving gifts isn‘t easy — there are two rules Limak must obey to make friends happy:

  • No two friends can get balls of the same size.
  • No two friends can get balls of sizes that differ by more than 2.

For example, Limak can choose balls with sizes 4, 5 and 3,
or balls with sizes 90, 91 and 92.
But he can‘t choose balls with sizes 5, 5and 6 (two
friends would get balls of the same size), and he can‘t choose balls with sizes 30, 31 and 33 (because
sizes 30 and 33 differ by more than 2).

Your task is to check whether Limak can choose three balls that satisfy conditions above.

Input

The first line of the input contains one integer n (3?≤?n?≤?50) —
the number of balls Limak has.

The second line contains n integers t1,?t2,?...,?tn (1?≤?ti?≤?1000)
where ti denotes the size
of the i-th ball.

Output

Print "YES" (without quotes) if Limak can choose three balls of distinct sizes, such that any two of them differ by no more than 2.
Otherwise, print "NO" (without quotes).

Examples

input

4
18 55 16 17

output

YES

input

6
40 41 43 44 44 44

output

NO

input

8
5 972 3 4 1 4 970 971

output

YES

题目大意:

就是给定 n 个数,让你求的就是是否存在三个连续的数。。。

解题思路:

这个题本来这么简单不想写的,但是突然发现一个函数还是比较不错的,unique(),就是这个函数,本来我是打算暴力的后来一寻思太麻烦了,就用集合写的,写到一半突然发现迭代器 it 不能加2,所以炸了,后来就用一个数组存的每一个*it 的数,有点小麻烦,具体看我第一个代码

My First AC Code:

<span style="font-size:18px;">#include <iostream>
#include <algorithm>
#include <set>
#include <cstdio>
#include <cstring>
using namespace std;
set <int> s;
set <int> ::iterator it;
int a[105];
int main()
{
    int n, x;
    while(cin>>n)
    {
        for(int i=0; i<n; i++)
        {
            cin>>x;
            s.insert(x);
        }
        memset(a, 0, sizeof(a));
        int cnt = 0;
        for(it=s.begin(); it!=s.end(); it++)
            a[cnt++] = *it;///每个都存一遍 实在是没招了 set学的不好呀。。。
        bool ok = 0;
        for(int i=1; i<cnt; i++)
        {
            if(a[i]==a[i-1]+1 && a[i]+1==a[i+1])
            {
                ok = 1;
                break;
            }
        }
        if(ok)
            puts("YES");
        else
            puts("NO");
    }
    return 0;
}</span>

接下来我要说的就是这篇博客的重点了(有没有想到高中老师呀...)介绍一个 STL 算法,unique(),这个函数是用来去重的,这还是我一队友告诉我的呢,我感觉自己好low啊,我详细的说一下:

unique的功能是去除相邻的重复元素(只保留一个),其实它并不是真正意思上的把重复的元素删除,只是把重复的元素移到后面去了,然后还是保存到了原数组中,然后
返回去重后最后一个元素的地址,因为unique去除的是相邻的重复元素,所以一般用之前都会要排一下序。

int tmp = unique(a,a+n)-a;我们只需要写上这么一句话,就行了,别忘了最后还得减a因为这个函数返回的就是地址,所以要减去,而tmp这个变量里存的就是去重之后的数组的长度,还是比较不错的吧,上我第二个代码:

My Second AC Code:

<span style="font-size:18px;">#include <iostream>
#include <algorithm>
#include <cstdio>
using namespace std;

int a[105];
int main()
{
    int n, x;
    while(cin>>n)
    {
        for(int i=0; i<n; i++)
            cin>>a[i];
        sort(a,a+n);
        int tmp = unique(a,a+n)-a;///头文件 <algorithm>,还是挺好的,去重用的
        bool ok = 0;
        for(int i=1; i<tmp; i++)
        {
            if(a[i]==a[i-1]+1 && a[i]+1==a[i+1])
            {
                ok = 1;
                break;
            }
        }
        if(ok)
            puts("YES");
        else
            puts("NO");
    }
    return 0;
}
</span>

时间: 2024-12-20 13:03:53

CodeForces 653 A. Bear and Three Balls——(IndiaHacks 2016 - Online Edition (Div. 1 + Div. 2))的相关文章

codeforces 653A A. Bear and Three Balls(水题)

题目链接: A. Bear and Three Balls time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Limak is a little polar bear. He has n balls, the i-th ball has size ti. Limak wants to give one ball to each

Bet(The 2016 ACM-ICPC Asia China-Final Contest 思路题)

题目: The Codejamon game is on fire! Fans across the world are predicting and betting on which team will win the game. A gambling company is providing betting odds for all teams; the odds for the ith team is Ai :Bi . For each team, you can bet any posi

Codeforces A. Kyoya and Colored Balls(分步组合)

题目描述: Kyoya and Colored Balls time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Kyoya Ootori has a bag with n colored balls that are colored with k different colors. The colors are labeled f

HDU 3635 Dragon Balls (并查集)

Dragon Balls Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 3360    Accepted Submission(s): 1303 Problem Description Five hundred years later, the number of dragon balls will increase unexpect

Codeforces 460 D Little Victor and Set (构造)

题目链接 构造的好题.表示是看了题解才会做的. 假如[l,r]长度不超过4,直接暴力就行了. 假如[l,r]长度大于等于5,那么如果k = 1,显然答案应该是l:如果k=2,可以找到a^(a+1)=1:如果k=3,首先只取两个就得到一个下界为1,但是可能出现为0的情况,下面再仔细讨论.如果k>=4,可以找到两组a^(a + 1) = 1,所以答案是0. 现在剩下的问题就是如何判断k=3的情况答案能否为0了.答案为0时我们只有可能取了3个数,设它们为x,y,z,并且不妨设有l <= z <

CodeForces 757D Felicity&#39;s Big Secret Revealed(状压DP)

题意:给定一个01串,一个有效的n切割定义如下:一个横杠代表一次切割,第一条横杠前面的01串不算,最后一条横杠后面的01串不算,将两个横杠中的01串转化成十进制数字,假设这些数字的最大值是MAX且这些数字囊括了1-MAX的所有数字,则称为一次有效切割.求2~n+1次有效切割的切法. 思路: 由于题目要求包含所有1-MAXN的数字,且n<=75,所以MAXN<=20.另dp[i][j]表示第i位前面有一个横杆且存在j这个状态,接着从第i位开始枚举到第j位为下一个横杆的位置,设这两段横杆之间的数字

[2016-04-04][codeforces][639][A][Bear and Displayed Friends]

时间:2016-04-04 12:38:53 星期一 题目编号:[2016-04-04][codeforces][639][A][Bear and Displayed Friends] 题目大意:有n朋友,第i个朋友有亲密度ti,有q次命令,1 id表示编号为id的朋友上线,2 id表示是否在线,且亲密度在前k个,输出结果 分析:可以发现k最大为0,只需要维护前k个最大值就ok,每加入一个数字就维护一次最大值 #include <cstring> #include <cstdio>

CodeForces 686B Little Robber Girl&#39;s Zoo (构造冒泡排序)

题意:给定一排列,让你通过一个区间交换的方式,完成排序. 析:这个题说了,最多不能超过20000次,而 n 最大才100,那么冒泡排序复杂度为 n * n,才10000,肯定是可以的,所以我们就模拟冒泡排序. 代码如下: #include <iostream> #include <cmath> #include <cstdlib> #include <set> #include <cstdio> #include <cstring>

[2016-04-04][codeforces][639][B][Bear and Forgotten Tree 3]

时间:2016-04-04 13:11:25 星期一 题目编号:[2016-04-04][codeforces][639][B][Bear and Forgotten Tree 3] 题目大意:一棵树有n个节点,直径为d,直径为h,问,这样的树是否存在,是则输出任意一棵树的所有边 分析: 树的高度是h,那么树的直径最大为2h 所以d?2×hd?2×h 所以只需要生成第一个枝条深度为h,其他枝条深度为d-h的树即可 如果d>2×hd>2×h,那么这样的树就不存在 d == h,剩下的节点不能放在